<!-- 
 * @Description: 寝室管理
 * @Author: syy 
 * @Date: 2024-7-15
-->
<template>
  <div class="main-box">
    <TreeFilter
      ref="treeFilter"
      title="宿舍楼管理"
      label="name"
      id="id"
      width="300px"
      :show-all="true"
      :request-api="userManageDormitoryApi.list"
      @change="changeTreeFilter"
    >
      <template v-slot:header>
        <s-button suffix="宿舍楼" @click="addDormitory(FormOptEnum.ADD)" style="margin-bottom: 15px" />
      </template>
      <template v-slot:label="{ row }">
        <span class="custom-tree-node">
          <span>{{ row.node.label }}</span>
          <span v-if="row.node.label != '全部'">
            <a :title="FormOptEnum.EDIT" @click.stop="addDormitory(FormOptEnum.EDIT, row.node.data)">
              <el-icon><Edit /></el-icon>
            </a>
            <a :title="FormOptEnum.DELETE" style="margin-left: 8px" @click.stop="addDelete(row.node.data.personSetId, '删除宿舍楼')">
              <el-icon><Delete /></el-icon>
            </a>
          </span>
        </span>
      </template>
    </TreeFilter>
    <div class="table-box">
      <ProTable ref="proTable" title="寝室管理" :columns="columns" rowKey="personId" :request-api="userManageDormitoryApi.page">
        <!-- 表格 header 按钮 -->
        <template #tableHeader="scope">
          <s-button v-auth="dormitoryButtonCode.add" suffix="寝室" @click="onOpen(FormOptEnum.ADD, { personSetId: personSetId })" />
          <s-button
            v-auth="dormitoryButtonCode.delete"
            type="danger"
            :opt="FormOptEnum.DELETE"
            plain
            suffix="寝室"
            :disabled="!scope.isSelected"
            @click="onDelete(scope.selectedListIds, '删除所选寝室')"
          />
        </template>
        <!-- 表格操作栏 -->
        <template #operation="scope">
          <el-space>
            <s-button v-auth="dormitoryButtonCode.edit" link :opt="FormOptEnum.EDIT" @click="onOpen(FormOptEnum.EDIT, scope.row)" />
            <s-button v-auth="dormitoryButtonCode.delete" link :opt="FormOptEnum.DELETE" @click="onDelete([scope.row.personId], `删除寝室`)" />
            <!-- <el-dropdown @command="handleCommand">
              <el-link type="primary" :underline="false" :icon="ArrowDown"> 更多 </el-link>
              <template #dropdown>
                <el-dropdown-menu>
                  <el-dropdown-item :command="command(scope.row, cmdEnum.AddFace)"
                    ><el-upload
                      ref="upload"
                      class="upload-demo"
                      action="/api/business/personApi/uploadFile"
                      :show-file-list="false"
                      :on-success="handleAvatarSuccess"
                      accept=".jpg, .jpeg, .png"
                      :headers="{
                        Authorization: `${TokenEnum.TOKEN_PREFIX} ${accessToken}`
                      }"
                    >
                      <template #trigger>
                        {{ cmdEnum.AddFace }}
                      </template>
                    </el-upload>
                  </el-dropdown-item>
                  <el-dropdown-item :command="command(scope.row, cmdEnum.UnderpantsUnBinding)">
                    {{ cmdEnum.UnderpantsUnBinding }}
                  </el-dropdown-item>
                </el-dropdown-menu>
              </template>
            </el-dropdown> -->
          </el-space>
        </template>
      </ProTable>
    </div>
    <!-- 寝室新增/编辑表单 -->
    <Form ref="formRef"></Form>
    <!-- 宿舍楼新增/编辑表单 -->
    <FormClass ref="formRefC" />
    <!-- 班主任绑定/修改 -->
    <FormTeacher ref="formRefT" />
    <!-- 预览头像 -->
    <el-dialog v-model="visible" title="查看头像" width="830px" :before-close="handleClose">
      <div style="display: flex; align-items: center; justify-content: center">
        <img style="max-width: 100%; max-height: 600px" class="detailpic" :src="faceUrl" alt="" />
      </div>
    </el-dialog>
  </div>
</template>
<script setup lang="tsx" name="SysDormitory">
import { userManageDormitoryApi,dormitoryButtonCode,SysDormitory } from "@/api";
import { useHandleData } from "@/hooks/useHandleData";
import { FormOptEnum } from "@/enums";
import Form from "./components/form/index.vue";
import FormClass from "./components/formClass/index.vue";
import FormTeacher from "./components/formTeacher/index.vue";
import { ArrowDown,More } from "@element-plus/icons-vue";
import { ColumnProps, ProTableInstance } from "@/components/ProTable/interface";
import TreeFilter from "@/components/TreeFilter/index.vue";
import { useUserStore } from "@/stores/modules";
import { TokenEnum } from "@/enums";
import type { UploadProps } from "element-plus";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const faceUrl = ref('');
const visible = ref(false); //是否显示寝室表单
const proTable = ref<ProTableInstance>();
const treeFilter = ref<InstanceType<typeof TreeFilter> | null>(null);
const userStore = useUserStore();
const { accessToken } = userStore;
// 表格配置项
const columns: ColumnProps<SysDormitory.ChamberInfo>[] = [
  { type: "selection", fixed: "left", width: 50 },
  {
    prop: "name",
    label: "寝室名称"
  },
  {
    prop: "personId",
    label: "寝室数量"
  },
 
  // { prop: "operation", label: "操作", width: 250, fixed: "right" }
];
const viewHeadImage = (scope: any) => {
  faceUrl.value = scope.row.faces[0].faceUrl;
  visible.value = true
  console.log(faceUrl);
};
const handleClose = () => {
  visible.value = false;
};
const tableData = ref([
  {
    name: "203",
    personId: "20",
  },
  
]);

// 寝室表单引用
const formRef = ref<InstanceType<typeof Form> | null>(null);
// 宿舍楼表单引用
const formRefC = ref<InstanceType<typeof FormClass> | null>(null);
// 宿舍楼表单引用
const formRefT = ref<InstanceType<typeof FormTeacher> | null>(null);

/**
 * 打开表单
 * @param opt  操作类型
 * @param record  记录
 */
function onOpen(opt: FormOptEnum, record: {} | SysDormitory.ChamberInfo = {}) {
  formRef.value?.onOpen({ opt: opt, record: record, successful: RefreshTable });
}

/**
 * 打开宿舍楼表单
 * @param opt  操作类型
 * @param record  记录
 */

 function addDormitory(opt: FormOptEnum, record: {} | SysDormitory.DormitoryInfo = {}) {
  formRefC.value?.onOpen({ opt: opt, record: JSON.parse(JSON.stringify(record)), successful: RefreshTable });
}
/**
 * 宿舍楼删除
 * @param ids  id数组
 */
 async function addDelete(id: string[],msg: string) {
  // 二次确认 => 请求api => 刷新表格
  await useHandleData(userManageClassManageApi.delete, { id }, msg);
  RefreshTable(); //刷新表格
}

/**
 * 寝室删除
 * @param ids  id数组
 */
 async function onDelete(ids: string[], msg: string) {
  if(ids.length === 0){
    ElMessage({
      message: '请选择要删除的寝室',
      type: 'warning'
    });
    return
  }
  // 二次确认 => 请求api => 刷新表格
  await useHandleData(userManagePersonnelApi.delete, {id: ids.join(",") }, msg);
  RefreshTable(); //刷新表格
}

// 刷新表格
const RefreshTable = () => {
  proTable.value?.refresh();
  treeFilter.value?.refresh(); //刷新树形筛选器
}


/** 更多下拉菜单命令枚举 */
enum cmdEnum {
  AddFace = "添加人脸",
  UnderpantsUnBinding = "底库解绑"
}
/** 下拉菜单参数接口 */
interface Command {
  row: SysDormitory.ChamberInfo;
  command: cmdEnum;
}

/**配置command的参数 */
function command(row: SysDormitory.ChamberInfo, command: cmdEnum): Command {
  return {
    row: row,
    command: command
  };
}
/**
 * 列表更多下拉菜单点击事件
 * @param command
 */
const personId = ref<number | string>(); //寝室id
function handleCommand(command: Command) {
  switch (command.command) {
    case cmdEnum.AddFace:
      personId.value = command.row.personId; //获取寝室id
      break
    case cmdEnum.UnderpantsUnBinding:
      userManagePersonnelApi.personUnBindDfie({
        personId:command.row.personId,
        personSetId: command.row.personSets[0].personSetId
      }).then(res=>{
          ElMessage.success('底库解绑成功');
          RefreshTable()
      })
      break;
  }
}


const handleAvatarSuccess: UploadProps["onSuccess"] = (response) => {
  if (response.code === 200) {
    userManagePersonnelApi.addFace({
      personId: personId.value,
      faceUrl: response.data
    }).then(res=>{
      RefreshTable()
    })
  } else {
    ElMessage.error(response.msg);
  }
};

/** 部门切换 */
const personSetId = ref<number | string>()
function changeTreeFilter(val: number | string) {
  personSetId.value = val
  proTable.value!.pageable.pageNum = 1;
  proTable.value!.searchParam.personSetId = val;
  proTable.value!.search();
}
</script>
<style scoped lang="scss">
.table-box {
  width: 100%;
  height: 100%;
}
.custom-tree-node {
  display: flex;
  flex: 1;
  align-items: center;
  justify-content: space-between;
  padding-right: 8px;
  font-size: 14px;
}
</style>
